//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
#include <avr/io.h>
//
void USART_Init(int baud)
{
UBRR0H = (unsigned char)(baud>>8);
UBRR0L = (unsigned char)baud;
UCSR0B = (1<<RXEN0)|(1<<TXEN0);
UCSR0C = (3<<UCSZ00);
}
//
void USART_PutChar(unsigned char data)
{
while (!(UCSR0A & (1 << UDRE0)));
UDR0 = data;
}
//
unsigned char USART_GetChar(void)
{
while (!(UCSR0A & (1 << RXC0)));
return UDR0;
}
//
void USART_PutString(char * s)
{
while(*s)
	USART_PutChar(*s++);
}
//
void USART_GetString(char * s)
{
char ch;

do{
  ch = USART_GetChar();
  USART_PutChar(ch);
  *s++ = ch;
  if(ch == 0x0D) *s = 0;
}while(ch != 0x0D);
}

char * Hex(char val, char*str)
{
*str = ((val >> 4) < 10 )?(val >> 4)+'0':(val >> 4)+'7';
*(str+1) = ((val & 0xF) < 10 )?(val & 0xF)+'0':(val & 0xF)+'7';
*(str+2) = 0;
return str;
}
